Index: /trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -82,5 +82,5 @@
     }
   }
-#if NH_3D_VSP
+#if NH_3D
   m_pDepthBlock = (Int*) malloc(MAX_NUM_PART_IDXS_IN_CTU_WIDTH*MAX_NUM_PART_IDXS_IN_CTU_WIDTH*sizeof(Int));
   if (m_pDepthBlock == NULL)
@@ -94,5 +94,5 @@
 TComPrediction::~TComPrediction()
 {
-#if NH_3D_VSP
+#if NH_3D
   if (m_pDepthBlock != NULL)
   {
@@ -123,5 +123,5 @@
   m_cYuvPredTemp.destroy();
 
-#if NH_3D_ARP
+#if NH_3D
   m_acYuvPredBase[0].destroy();
   m_acYuvPredBase[1].destroy();
@@ -182,14 +182,10 @@
 
     m_cYuvPredTemp.create( MAX_CU_SIZE, MAX_CU_SIZE, chromaFormatIDC );
-#if NH_3D_ARP
+#if NH_3D
     m_acYuvPredBase[0] .create( MAX_CU_SIZE, MAX_CU_SIZE, chromaFormatIDC );
     m_acYuvPredBase[1] .create( MAX_CU_SIZE, MAX_CU_SIZE, chromaFormatIDC );
-#endif
-#if NH_3D_VSP
-    m_cYuvDepthOnVsp.create( MAX_CU_SIZE, MAX_CU_SIZE, chromaFormatIDC );
-#endif
-
-  }
-
+    m_cYuvDepthOnVsp   .create( MAX_CU_SIZE, MAX_CU_SIZE, chromaFormatIDC );
+#endif
+  }
 
   if (m_iLumaRecStride != (MAX_CU_SIZE>>1) + 1)
@@ -201,5 +197,5 @@
     }
   }
-#if NH_3D_IC
+#if NH_3D
   m_uiaShift[0] = 0;
   for( Int i = 1; i < 64; i++ )
@@ -508,12 +504,10 @@
 }
 
-#if NH_3D_DMM
+#if NH_3D
 Void TComPrediction::predIntraLumaDmm( TComDataCU* pcCU, UInt uiAbsPartIdx, DmmID dmmType, Pel* piPred, UInt uiStride, Int iWidth, Int iHeight )
 {
   assert( iWidth == iHeight  );
   assert( iWidth >= DMM_MIN_SIZE && iWidth <= DMM_MAX_SIZE );
-#if NH_3D_SDC_INTRA
   assert( !pcCU->getSDCFlag( uiAbsPartIdx ) );
-#endif
 
   // get partition
@@ -535,11 +529,6 @@
   Pel deltaDC1 = pcCU->getDmmDeltaDC( dmmType, 0, uiAbsPartIdx );
   Pel deltaDC2 = pcCU->getDmmDeltaDC( dmmType, 1, uiAbsPartIdx );
-#if NH_3D_DLT
   segDC1 = pcCU->getSlice()->getPPS()->getDLT()->idx2DepthValue( pcCU->getSlice()->getLayerIdInVps(), pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), predDC1 ) + deltaDC1 );
   segDC2 = pcCU->getSlice()->getPPS()->getDLT()->idx2DepthValue( pcCU->getSlice()->getLayerIdInVps(), pcCU->getSlice()->getPPS()->getDLT()->depthValue2idx( pcCU->getSlice()->getLayerIdInVps(), predDC2 ) + deltaDC2 );
-#else
-  segDC1 = ClipBD( predDC1 + deltaDC1, pcCU->getSlice()->getSPS()->getBitDepth(CHANNEL_TYPE_LUMA) );
-  segDC2 = ClipBD( predDC2 + deltaDC2, pcCU->getSlice()->getSPS()->getBitDepth(CHANNEL_TYPE_LUMA) );
-#endif
 
   // set prediction signal
@@ -565,5 +554,5 @@
       Int layerIdL0 = pcCU->getSlice()->getRefPic(REF_PIC_LIST_0, pcCU->getCUMvField(REF_PIC_LIST_0)->getRefIdx(PartAddr))->getLayerId();
       Int layerIdL1 = pcCU->getSlice()->getRefPic(REF_PIC_LIST_1, pcCU->getCUMvField(REF_PIC_LIST_1)->getRefIdx(PartAddr))->getLayerId();
-#if NH_3D_ARP
+#if NH_3D
       if(!pcCU->getARPW(PartAddr) && RefPOCL0 == RefPOCL1 && layerIdL0 == layerIdL1 && pcCU->getCUMvField(REF_PIC_LIST_0)->getMv(PartAddr) == pcCU->getCUMvField(REF_PIC_LIST_1)->getMv(PartAddr))
 #else
@@ -581,5 +570,5 @@
 }
 
-#if NH_3D_SPIVMP
+#if NH_3D
 Void TComPrediction::xGetSubPUAddrAndMerge(TComDataCU* pcCU, UInt uiPartAddr, Int iSPWidth, Int iSPHeight, Int iNumSPInOneLine, Int iNumSP, UInt* uiMergedSPW, UInt* uiMergedSPH, UInt* uiSPAddr )
 {
@@ -590,10 +579,9 @@
     pcCU->getSPAbsPartIdx(uiPartAddr, iSPWidth, iSPHeight, i, iNumSPInOneLine, uiSPAddr[i]);
   }
-#if NH_3D_ARP
+
   if( pcCU->getARPW( uiPartAddr ) != 0 )
   {
     return;
   }
-#endif
 
   // horizontal sub-PU merge
@@ -667,7 +655,5 @@
   return true;
 }
-#endif
-
-#if NH_3D_DBBP
+
 PartSize TComPrediction::getPartitionSizeFromDepth(Pel* pDepthPels, UInt uiDepthStride, UInt uiSize, TComDataCU*& pcCU)
 {
@@ -1138,5 +1124,5 @@
   {
     pcCU->getPartIndexAndSize( iPartIdx, uiPartAddr, iWidth, iHeight );
-#if NH_3D_VSP
+#if NH_3D
     if ( pcCU->getVSPFlag(uiPartAddr) == 0)
     {
@@ -1156,5 +1142,5 @@
      else
      {
-#if NH_3D_SPIVMP
+#if NH_3D
         if ( pcCU->getSPIVMPFlag(uiPartAddr)!=0)  
         {
@@ -1196,9 +1182,9 @@
             xPredInterBi  (pcCU, uiPartAddr, iWidth, iHeight, pcYuvPred );
           }
-#if NH_3D_SPIVMP
+#if NH_3D
         }
 #endif
       }
-#if NH_3D_VSP
+#if NH_3D
     }
     else
@@ -1221,5 +1207,5 @@
     pcCU->getPartIndexAndSize( iPartIdx, uiPartAddr, iWidth, iHeight );
 
-#if NH_3D_VSP
+#if NH_3D
     if ( pcCU->getVSPFlag(uiPartAddr) == 0 )
     {
@@ -1239,5 +1225,5 @@
     else
     {
-#if NH_3D_SPIVMP
+#if NH_3D
       if (pcCU->getSPIVMPFlag(uiPartAddr)!=0)  
       {
@@ -1278,9 +1264,9 @@
           xPredInterBi  (pcCU, uiPartAddr, iWidth, iHeight, pcYuvPred );
         }
-#if NH_3D_SPIVMP
-      }
-#endif
-    }
-#if NH_3D_VSP
+#if NH_3D
+      }
+#endif
+    }
+#if NH_3D
     }
     else
@@ -1319,5 +1305,5 @@
   pcCU->checkMvVertRest(cMv, eRefPicList, iRefIdx );
 #endif
-#if NH_3D_ARP
+#if NH_3D
   if(  pcCU->getARPW( uiPartAddr ) > 0 )
   {
@@ -1338,21 +1324,18 @@
     {
       const ComponentID compID=ComponentID(comp);
-#if NH_3D_IC
+#if NH_3D
       Bool bICFlag = pcCU->getICFlag( uiPartAddr ) && ( pcCU->getSlice()->getRefPic( eRefPicList, iRefIdx )->getViewIndex() != pcCU->getSlice()->getViewIndex() ) && ( isLuma(compID) || (iWidth > 8) );
       xPredInterBlk(compID,  pcCU, pcCU->getSlice()->getRefPic( eRefPicList, iRefIdx )->getPicYuvRec(), uiPartAddr, &cMv, iWidth, iHeight, pcYuvPred, bi, pcCU->getSlice()->getSPS()->getBitDepth(toChannelType(compID))
-#if NH_3D_ARP
-        , false
-#endif
-        , bICFlag );
+        , false, bICFlag );
 #else
       xPredInterBlk  (compID,  pcCU, pcCU->getSlice()->getRefPic( eRefPicList, iRefIdx )->getPicYuvRec(), uiPartAddr, &cMv, iWidth, iHeight, pcYuvPred, bi, pcCU->getSlice()->getSPS()->getBitDepth(toChannelType(compID)) );
 #endif
     }
-#if NH_3D_ARP
-  }
-#endif
-}
-
-#if NH_3D_VSP
+#if NH_3D
+  }
+#endif
+}
+
+#if NH_3D
 Void TComPrediction::xPredInterUniVSP( TComDataCU* pcCU, UInt uiPartAddr, Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi )
 {
@@ -1399,5 +1382,5 @@
 #endif
 
-#if NH_3D_ARP
+#if NH_3D
 //temporal ARP
 Void TComPrediction::xPredInterUniARP( TComDataCU* pcCU, UInt uiPartAddr, Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi )
@@ -1409,11 +1392,8 @@
   TComPic* pcPicYuvBaseRef = NULL;
 
-#if NH_3D_NBDV
   DisInfo cDistparity;
   cDistparity.m_acNBDV = pcCU->getDvInfo(0).m_acNBDV;
   cDistparity.m_aVIdxCan = pcCU->getDvInfo(uiPartAddr).m_aVIdxCan;
-#else
-  assert(0); // ARP can be applied only when a DV is available
-#endif
+
   UChar dW = pcCU->getARPW ( uiPartAddr );
 
@@ -1777,5 +1757,5 @@
 }
 
-#if NH_3D_VSP
+#if NH_3D
 Void TComPrediction::xPredInterBiVSP( TComDataCU* pcCU, UInt uiPartAddr, Int iWidth, Int iHeight, TComYuv*& rpcYuvPred )
 {
@@ -1821,11 +1801,5 @@
 #if NH_3D
 Void TComPrediction::xPredInterBlk(const ComponentID compID, TComDataCU *cu, TComPicYuv *refPic, UInt partAddr, TComMv *mv, Int width, Int height, TComYuv *dstPic, Bool bi, const Int bitDepth 
-#if NH_3D_ARP
-    , Bool filterType
-#endif
-#if NH_3D_IC
-    , Bool bICFlag
-#endif
-)
+    , Bool filterType , Bool bICFlag )
 #else
 Void TComPrediction::xPredInterBlk(const ComponentID compID, TComDataCU *cu, TComPicYuv *refPic, UInt partAddr, TComMv *mv, Int width, Int height, TComYuv *dstPic, Bool bi, const Int bitDepth )
@@ -1849,5 +1823,5 @@
   Int     yFrac  = mv->getVer() & ((1<<shiftVer)-1);
 
-#if NH_3D_INTEGER_MV_DEPTH
+#if NH_3D
   if( cu->getSlice()->getIsDepth() )
   {
@@ -1868,12 +1842,5 @@
 #if NH_3D
     m_if.filterHor(compID, ref, refStride, dst,  dstStride, cxWidth, cxHeight, xFrac, !bi 
-#if NH_3D_IC
-     || bICFlag
-#endif
-    , chFmt, bitDepth
-#if NH_3D_ARP 
-    , filterType
-#endif 
-);
+     || bICFlag, chFmt, bitDepth, filterType );
 #else
     m_if.filterHor(compID, ref, refStride, dst,  dstStride, cxWidth, cxHeight, xFrac, !bi, chFmt, bitDepth );
@@ -1884,15 +1851,7 @@
 #if NH_3D
   m_if.filterVer(compID, ref, refStride, dst, dstStride, cxWidth, cxHeight, yFrac, true, !bi 
-#if NH_3D_IC
-    || bICFlag
-#endif
-    , chFmt, bitDepth
-#if NH_3D_ARP
-    , filterType
-#endif
-);
+    || bICFlag , chFmt, bitDepth , filterType );
 #else
     m_if.filterVer(compID, ref, refStride, dst, dstStride, cxWidth, cxHeight, yFrac, true, !bi, chFmt, bitDepth );
-
 #endif
   }
@@ -1904,5 +1863,5 @@
     const Int vFilterSize = isLuma(compID) ? NTAPS_LUMA : NTAPS_CHROMA;
 
-#if NH_3D_ARP 
+#if NH_3D
     m_if.filterHor(compID, ref - ((vFilterSize>>1) -1)*refStride, refStride, tmp, tmpStride, cxWidth, cxHeight+vFilterSize-1, xFrac, false,      chFmt, bitDepth, filterType );
 #else
@@ -1912,12 +1871,5 @@
 #if NH_3D
     m_if.filterVer(compID, tmp + ((vFilterSize>>1) -1)*tmpStride, tmpStride, dst, dstStride, cxWidth, cxHeight,               yFrac, false, !bi
-#if NH_3D_IC
-    || bICFlag
-#endif
-    , chFmt, bitDepth
-#if NH_3D_ARP
-    , filterType
-#endif 
-);
+    || bICFlag , chFmt, bitDepth , filterType );
 #else
     m_if.filterVer(compID, tmp + ((vFilterSize>>1) -1)*tmpStride, tmpStride, dst, dstStride, cxWidth, cxHeight,               yFrac, false, !bi, chFmt, bitDepth );
@@ -1925,5 +1877,5 @@
   }
 
-#if NH_3D_IC
+#if NH_3D
   if( bICFlag )
   {
@@ -2104,5 +2056,276 @@
           (uiDirMode==HOR_IDX || uiDirMode==VER_IDX);
 }
-#if NH_3D_IC
+
+
+#if MCTS_ENC_CHECK
+
+Void getRefPUPartPos(TComDataCU* pcCU, TComMv& cMv, Int uiPartIdx, Int& ruiPredXLeft, Int& ruiPredYTop, Int& ruiPredXRight, Int& ruiPredYBottom, Int iWidth, Int iHeight)
+{
+  ruiPredXLeft = pcCU->getCUPelX();
+  ruiPredYTop = pcCU->getCUPelY();
+
+  switch (pcCU->getPartitionSize(0))
+  {
+  case SIZE_2NxN:
+    if (uiPartIdx == 0)
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + iHeight;
+    }
+    else
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + (iHeight << 1);
+      ruiPredYTop += iHeight;
+    }
+    break;
+  case SIZE_Nx2N:
+    if (uiPartIdx == 0)
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + iHeight;
+    }
+    else
+    {
+      ruiPredXRight = ruiPredXLeft + (iWidth << 1);
+      ruiPredYBottom = ruiPredYTop + iHeight;
+      ruiPredXLeft += iWidth;
+    }
+    break;
+  case SIZE_NxN:
+    if (uiPartIdx == 0)
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + iHeight;
+    }
+    else if (uiPartIdx == 1)
+    {
+      ruiPredXRight = ruiPredXLeft + (iWidth << 1);
+      ruiPredYBottom = ruiPredYTop + iHeight;
+      ruiPredXLeft += iWidth;
+    }
+    else if (uiPartIdx == 2)
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + (iHeight << 1);
+      ruiPredYTop += iHeight;
+    }
+    else if (uiPartIdx == 3)
+    {
+      ruiPredXRight = ruiPredXLeft + (iWidth << 1);
+      ruiPredYBottom = ruiPredYTop + (iHeight << 1);
+      ruiPredXLeft += iWidth;
+      ruiPredYTop += iHeight;
+    }
+    break;
+  case SIZE_2NxnU:
+    if (uiPartIdx == 0)
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + iHeight;
+    }
+    else
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + pcCU->getHeight(0);
+      ruiPredYTop += (iHeight / 3);
+    }
+    break;
+  case SIZE_2NxnD:
+    if (uiPartIdx == 0)
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + iHeight;
+    }
+    else
+    {
+      Int oriHeight = iHeight << 2;
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + oriHeight;
+      ruiPredYTop += (oriHeight >> 2) + (oriHeight >> 1);
+    }
+    break;
+  case SIZE_nLx2N:
+    if (uiPartIdx == 0)
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + iHeight;
+    }
+    else
+    {
+      ruiPredXRight = ruiPredXLeft + pcCU->getWidth(0);
+      ruiPredYBottom = ruiPredYTop + iHeight;
+      ruiPredXLeft += (iWidth / 3);
+    }
+    break;
+  case SIZE_nRx2N:
+    if (uiPartIdx == 0)
+    {
+      ruiPredXRight = ruiPredXLeft + iWidth;
+      ruiPredYBottom = ruiPredYTop + iHeight;
+    }
+    else
+    {
+      Int oriWidth = (iWidth << 2);
+      ruiPredXRight = ruiPredXLeft + oriWidth;
+      ruiPredYBottom = ruiPredYTop + iHeight;
+      ruiPredXLeft += (oriWidth >> 2) + (oriWidth >> 1);
+    }
+    break;
+  default:
+    ruiPredXRight = ruiPredXLeft + iWidth;
+    ruiPredYBottom = ruiPredYTop + iHeight;
+    break;
+  }
+
+  ruiPredXLeft   += (cMv.getHor() >> 2);
+  ruiPredYTop    += (cMv.getVer() >> 2);
+  ruiPredXRight  += (cMv.getHor() >> 2) - 1;
+  ruiPredYBottom += (cMv.getVer() >> 2) - 1;
+}
+
+Bool checkMVPRange(TComMv& cMv, UInt ctuLength, UInt tileXPosInCtus, UInt tileYPosInCtus, UInt tileWidthtInCtus, UInt tileHeightInCtus, Int PredXLeft, Int PredXRight, Int PredYTop, Int PredYBottom, ChromaFormat chromaFormat)
+{
+  // filter length of sub-sample generation filter to be considered
+  const UInt LumaLTSampleOffset = 3;
+  const UInt LumaRBSampleOffset = 4;
+  const UInt CromaLTSampleoffset = 1;
+  const UInt CromaRBSampleoffset = 2;
+
+  // tile position in full pels
+  const Int leftTopPelPosX = ctuLength * tileXPosInCtus;
+  const Int leftTopPelPosY = ctuLength * tileYPosInCtus;
+  const Int rightBottomPelPosX = ((tileWidthtInCtus + tileXPosInCtus) * ctuLength) - 1;
+  const Int rightBottomPelPosY = ((tileHeightInCtus + tileYPosInCtus) * ctuLength) - 1;
+
+  // Luma MV range check
+  const Bool isFullPelHorLuma = (cMv.getHor() % 4 == 0);
+  const Bool isFullPelVerLuma = (cMv.getVer() % 4 == 0);
+
+  const Int lRangeXLeft = leftTopPelPosX + (isFullPelHorLuma ? 0 : LumaLTSampleOffset);
+  const Int lRangeYTop = leftTopPelPosY + (isFullPelVerLuma ? 0 : LumaLTSampleOffset);
+  const Int lRangeXRight = rightBottomPelPosX - (isFullPelHorLuma ? 0 : LumaRBSampleOffset);
+  const Int lRangeYBottom = rightBottomPelPosY - (isFullPelVerLuma ? 0 : LumaRBSampleOffset);
+
+  if (!(PredXLeft >= lRangeXLeft && PredXLeft <= lRangeXRight) || !(PredXRight >= lRangeXLeft && PredXRight <= lRangeXRight))
+  {
+    return false;
+  }
+  else if (!(PredYTop >= lRangeYTop && PredYTop <= lRangeYBottom) || !(PredYBottom >= lRangeYTop && PredYBottom <= lRangeYBottom))
+  {
+    return false;
+  }
+
+  if ((chromaFormat != CHROMA_444) && (chromaFormat != CHROMA_400))
+  {
+    // Chroma MV range check
+    const Bool isFullPelHorChroma = (cMv.getHor() % 8 == 0);
+    const Bool isFullPelVerChroma = (cMv.getVer() % 8 == 0);
+
+    const Int cRangeXLeft = leftTopPelPosX + (isFullPelHorChroma ? 0 : CromaLTSampleoffset);
+    const Int cRangeYTop = leftTopPelPosY + (isFullPelVerChroma ? 0 : CromaLTSampleoffset);
+    const Int cRangeXRight = rightBottomPelPosX - (isFullPelHorChroma ? 0 : CromaRBSampleoffset);
+    const Int cRangeYBottom = rightBottomPelPosY - (isFullPelVerChroma ? 0 : CromaRBSampleoffset);
+
+    if (!(PredXLeft >= cRangeXLeft && PredXLeft <= cRangeXRight) || !(PredXRight >= cRangeXLeft && PredXRight <= cRangeXRight))
+    {
+      return false;
+    }
+    else if ((!(PredYTop >= cRangeYTop && PredYTop <= cRangeYBottom) || !(PredYBottom >= cRangeYTop && PredYBottom <= cRangeYBottom)) && (chromaFormat != CHROMA_422))
+    {
+      return false;
+    }
+  }
+
+  return true;
+}
+
+Bool TComPrediction::checkTMctsMvp(TComDataCU* pcCU, Int partIdx)
+{
+  Int   partWidth  = 0;
+  Int   partHeight = 0;
+  UInt  partAddr   = 0;
+
+  UInt  tileXPosInCtus = 0;
+  UInt  tileYPosInCtus = 0;
+  UInt  tileWidthtInCtus = 0;
+  UInt  tileHeightInCtus = 0;
+  
+  getTilePosition(pcCU, tileXPosInCtus, tileYPosInCtus, tileWidthtInCtus, tileHeightInCtus);
+
+  const UInt            ctuLength = pcCU->getPic()->getPicSym()->getSPS().getMaxCUWidth();
+  const ChromaFormat chromaFormat = pcCU->getPic()->getPicSym()->getSPS().getChromaFormatIdc();
+
+  Int   predXLeft;
+  Int   predYTop;
+  Int   predXRight;
+  Int   predYBottom;
+
+  if (partIdx >= 0)
+  {
+    pcCU->getPartIndexAndSize(partIdx, partAddr, partWidth, partHeight);
+
+    if (xCheckIdenticalMotion(pcCU, partAddr))
+    {
+      RefPicList eRefPicList = REF_PIC_LIST_0;
+      TComMv      cMv = pcCU->getCUMvField(eRefPicList)->getMv(partAddr);
+      getRefPUPartPos(pcCU, cMv, partIdx, predXLeft, predYTop, predXRight, predYBottom, partWidth, partHeight);
+      if (!checkMVPRange(cMv, ctuLength, tileXPosInCtus, tileYPosInCtus, tileWidthtInCtus, tileHeightInCtus, predXLeft, predXRight, predYTop, predYBottom, chromaFormat))
+      {
+        return false;
+      }
+    }
+    else
+    {
+      for (UInt refList = 0; refList < NUM_REF_PIC_LIST_01; refList++)
+      {
+        RefPicList eRefPicList = (refList ? REF_PIC_LIST_1 : REF_PIC_LIST_0);
+
+        TComMv      cMv = pcCU->getCUMvField(eRefPicList)->getMv(partAddr);
+        getRefPUPartPos(pcCU, cMv, partIdx, predXLeft, predYTop, predXRight, predYBottom, partWidth, partHeight);
+        if (!checkMVPRange(cMv, ctuLength, tileXPosInCtus, tileYPosInCtus, tileWidthtInCtus, tileHeightInCtus, predXLeft, predXRight, predYTop, predYBottom, chromaFormat))
+        {
+          return false;
+        }
+      }
+    }
+    return true;
+  }
+
+  for (partIdx = 0; partIdx < pcCU->getNumPartitions(); partIdx++)
+  {
+    pcCU->getPartIndexAndSize(partIdx, partAddr, partWidth, partHeight);
+
+    if (xCheckIdenticalMotion(pcCU, partAddr))
+    {
+      RefPicList eRefPicList = REF_PIC_LIST_0;
+      TComMv      cMv = pcCU->getCUMvField(eRefPicList)->getMv(partAddr);
+      getRefPUPartPos(pcCU, cMv, partIdx, predXLeft, predYTop, predXRight, predYBottom, partWidth, partHeight);
+      if (!checkMVPRange(cMv, ctuLength, tileXPosInCtus, tileYPosInCtus, tileWidthtInCtus, tileHeightInCtus, predXLeft, predXRight, predYTop, predYBottom, chromaFormat))
+      {
+        return false;
+      }
+    }
+    else
+    {
+      for (UInt refList = 0; refList < NUM_REF_PIC_LIST_01; refList++)
+      {
+        RefPicList eRefPicList = (refList ? REF_PIC_LIST_1 : REF_PIC_LIST_0);
+
+        TComMv      cMv = pcCU->getCUMvField(eRefPicList)->getMv(partAddr);
+        getRefPUPartPos(pcCU, cMv, partIdx, predXLeft, predYTop, predXRight, predYBottom, partWidth, partHeight);
+        if (!checkMVPRange(cMv, ctuLength, tileXPosInCtus, tileYPosInCtus, tileWidthtInCtus, tileHeightInCtus, predXLeft, predXRight, predYTop, predYBottom, chromaFormat))
+        {
+          return false;
+        }
+      }
+    }
+  }
+  return true;
+}
+
+
+#endif
+#if NH_3D
 /** Function for deriving the position of first non-zero binary bit of a value
  * \param x input value
@@ -2130,5 +2353,4 @@
   return iMSB;
 }
-
 
 /** Function for deriving LM illumination compensation.
@@ -2252,6 +2474,5 @@
   }   
 #endif
-
-#if NH_3D_SDC_INTRA
+#if NH_3D
 Void TComPrediction::predConstantSDC( Pel* ptrSrc, UInt srcStride, UInt uiSize, Pel& predDC )
 {
@@ -2262,7 +2483,5 @@
   predDC = (*pLeftTop + *pRightTop + *pLeftBottom + *pRightBottom + 2)>>2;
 }
-#endif // NH_3D_SDC_INTRA
-
-#if NH_3D_DMM
+
 Void TComPrediction::predContourFromTex( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, Bool* segPattern )
 {
Index: /trunk/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 1412)
+++ /trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 1413)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2016, ITU/ISO/IEC
+ * Copyright (c) 2010-2017, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -45,5 +45,5 @@
 #include "TComWeightPrediction.h"
 
-#if NH_3D_ARP
+#if NH_3D
 #include "TComPic.h"
 #endif
@@ -80,5 +80,5 @@
   TComYuv   m_acYuvPred[NUM_REF_PIC_LIST_01];
   TComYuv   m_cYuvPredTemp;
-#if NH_3D_ARP
+#if NH_3D
   TComYuv   m_acYuvPredBase[2];
 #endif
@@ -90,9 +90,6 @@
   Pel*   m_pLumaRecBuffer;       ///< array for downsampled reconstructed luma sample
   Int    m_iLumaRecStride;       ///< stride of #m_pLumaRecBuffer array
-#if NH_3D_IC
+#if NH_3D
   UInt   m_uiaShift[ 64 ];       // Table for multiplication to substitue of division operation
-#endif
-
-#if NH_3D_VSP
   Int*    m_pDepthBlock;         ///< Store a depth block, local variable, to prevent memory allocation every time
   TComYuv m_cYuvDepthOnVsp;
@@ -102,5 +99,5 @@
 
   // motion compensation functions
-#if NH_3D_ARP
+#if NH_3D
   Void xPredInterUniARP         ( TComDataCU* pcCU,                          UInt uiPartAddr,               Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi );
   Void xPredInterUniARPviewRef  ( TComDataCU* pcCU,                          UInt uiPartAddr,               Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi );
@@ -110,22 +107,13 @@
   Void xPredInterUni            ( TComDataCU* pcCU,                          UInt uiPartAddr,               Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv* pcYuvPred, Bool bi=false          );
   Void xPredInterBi             ( TComDataCU* pcCU,                          UInt uiPartAddr,               Int iWidth, Int iHeight,                         TComYuv* pcYuvPred          );
-#if NH_3D_VSP
+#if NH_3D
   Void xPredInterUniVSP         ( TComDataCU* pcCU,                          UInt uiPartAddr,               Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi=false          );
   Void xPredInterBiVSP          ( TComDataCU* pcCU,                          UInt uiPartAddr,               Int iWidth, Int iHeight,                         TComYuv*& rpcYuvPred );
+  Void xPredInterBlk(const ComponentID compID, TComDataCU *cu, TComPicYuv *refPic, UInt partAddr, TComMv *mv, Int width, Int height, TComYuv *dstPic, Bool bi, const Int bitDepth, Bool filterType = false, Bool bICFlag    = false );
+#else
+  Void xPredInterBlk(const ComponentID compID, TComDataCU *cu, TComPicYuv *refPic, UInt partAddr, TComMv *mv, Int width, Int height, TComYuv *dstPic, Bool bi, const Int bitDepth );
 #endif
 
 #if NH_3D
-  Void xPredInterBlk(const ComponentID compID, TComDataCU *cu, TComPicYuv *refPic, UInt partAddr, TComMv *mv, Int width, Int height, TComYuv *dstPic, Bool bi, const Int bitDepth
-#if NH_3D_ARP
-    , Bool filterType = false
-#endif
-#if NH_3D_IC
-    , Bool bICFlag    = false
-#endif
- );
-#else
-  Void xPredInterBlk(const ComponentID compID, TComDataCU *cu, TComPicYuv *refPic, UInt partAddr, TComMv *mv, Int width, Int height, TComYuv *dstPic, Bool bi, const Int bitDepth );
-#endif
-#if NH_3D_VSP
   Void xPredInterUniSubPU        ( TComDataCU *cu, UInt uiPartAddr, Int iWidth, Int iHeight, RefPicList eRefPicList, TComYuv*& rpcYuvPred, Bool bi, Int widthSubPU=4, Int heightSubPU=4 );
 #endif
@@ -134,10 +122,10 @@
 
   Void xGetLLSPrediction ( const Pel* pSrc0, Int iSrcStride, Pel* pDst0, Int iDstStride, UInt uiWidth, UInt uiHeight, UInt uiExt0, const ChromaFormat chFmt  DEBUG_STRING_FN_DECLARE(sDebug) );
-#if NH_3D_IC
+#if NH_3D
   Void xGetLLSICPrediction( const ComponentID compID, TComDataCU* pcCU, TComMv *pMv, TComPicYuv *pRefPic, Int &a, Int &b, const Int bitDepth);
 #endif
   Void xDCPredFiltering( const Pel* pSrc, Int iSrcStride, Pel* pDst, Int iDstStride, Int iWidth, Int iHeight, ChannelType channelType );
   Bool xCheckIdenticalMotion    ( TComDataCU* pcCU, UInt PartAddr);
-#if NH_3D_SPIVMP
+#if NH_3D
   Bool xCheckTwoSPMotion ( TComDataCU* pcCU, UInt PartAddr0, UInt PartAddr1 );
   Void xGetSubPUAddrAndMerge(TComDataCU* pcCU, UInt uiPartAddr, Int iSPWidth, Int iSPHeight, Int iNumSPInOneLine, Int iNumSP, UInt* uiMergedSPW, UInt* uiMergedSPH, UInt* uiSPAddr );
@@ -164,20 +152,13 @@
 
   Pel  predIntraGetPredValDC      ( const Pel* pSrc, Int iSrcStride, UInt iWidth, UInt iHeight);
-#if NH_3D_DMM
+#if NH_3D
   Void predIntraLumaDmm           ( TComDataCU* pcCU, UInt uiAbsPartIdx, DmmID dmmType, Pel* piPred, UInt uiStride, Int iWidth, Int iHeight );
   Void predContourFromTex         ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, Bool* segPattern );
   Void predBiSegDCs               ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiWidth, UInt uiHeight, Bool* biSegPattern, Int patternStride, Pel& predDC1, Pel& predDC2 );
   Void assignBiSegDCs             ( Pel* ptrDst, UInt dstStride, Bool* biSegPattern, Int patternStride, Pel valDC1, Pel valDC2 );
-#endif
-#if NH_3D_SDC_INTRA
   Void predConstantSDC            ( Pel* ptrSrc, UInt srcStride, UInt uiSize, Pel& predDC );
-#endif
-  
-#if NH_3D_DBBP
   PartSize      getPartitionSizeFromDepth(Pel* pDepthPels, UInt uiDepthStride, UInt uiSize, TComDataCU*& pcCU);
   Bool          getSegmentMaskFromDepth( Pel* pDepthPels, UInt uiDepthStride, UInt uiWidth, UInt uiHeight, Bool* pMask, TComDataCU*& pcCU);
   Void          combineSegmentsWithMask( TComYuv* pInYuv[2], TComYuv* pOutYuv, Bool* pMask, UInt uiWidth, UInt uiHeight, UInt uiPartAddr, UInt partSize, Int bitDepthY );
-#endif
-#if NH_3D
   Pel  predIntraGetPredValDC      ( const Pel* pSrc, Int iSrcStride, UInt iWidth, UInt iHeight, Bool bAbove, Bool bLeft );
 #endif
@@ -197,4 +178,8 @@
 
   static Bool UseDPCMForFirstPassIntraEstimation(TComTU &rTu, const UInt uiDirMode);
+
+#if MCTS_ENC_CHECK
+  Bool checkTMctsMvp(TComDataCU* pcCU, Int partIdx = -1);
+#endif
 };
 
